package com.fetchingStratergy.repository.impl;

import java.util.List;

/*import org.hibernate.Criteria;
import org.hibernate.FetchMode;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Expression;*/
import org.springframework.orm.hibernate3.HibernateTemplate;

import com.fetchingStratergy.domain.Employee;
import com.fetchingStratergy.fetchingPattern.EmployeeFetchingStrategy;
import com.fetchingStratergy.repository.EmployeeRepository;

public class EmployeeRepositoryImpl implements EmployeeRepository {
	
	public EmployeeFetchingStrategy fetchingStrategy;
	private HibernateTemplate hibernateTemplate;
	
	public EmployeeRepositoryImpl(EmployeeFetchingStrategy fetchingStrategy,
			HibernateTemplate hibernateTemplate) {
		super();
		this.fetchingStrategy = fetchingStrategy;
		this.hibernateTemplate = hibernateTemplate;
	}

	public void createEmployee(Employee employee) {
		hibernateTemplate.save(employee);
	}

	public void deleteEmployee(Employee employee) {
		hibernateTemplate.delete(employee);
	}

	public Employee findEmployeeById(int employeeId) {
		List employee = hibernateTemplate.find(fetchingStrategy.queryEmployeeById(), new Integer(employeeId));
		
		if(employee.size() == 0)
			return null;
		
		return (Employee)employee.get(0);
	}

}
